import 'package:json_annotation/json_annotation.dart';
import 'message_element.dart';

part 'message.g.dart';

@JsonSerializable()
class Message extends Object with _$MessageSerializerMixin {
	Message(this.time,this.count,this.elements,this.sender);

	int time;
	int count;
	String sender;
	List<MessageElement> elements;

	factory Message.fromJson(Map<String, dynamic> json) => _$MessageFromJson(json);

	static Message createFromJson(dynamic json){
		return new Message(
				json['time'] as int,
				json['count'] as int,
				(json['elements'] as List)
						?.map((e) => e == null
						? null
						: new MessageElement.fromJson(e as Map<String, dynamic>))
						?.toList(),
				json['sender'] as String);
	}
}